# == Class: apache
#
# === Examples
#
#  class { 'apache':
#    servername      => 'www.example.com',
#  }
#
# === Authors
#
# Aneesh C <aneeshchandrasekharan@gmail.com>
#

class apache (
  $package_name          = $::apache::params::package_name,
  $configfile            = $::apache::params::configfile,
  $configfile_ports      = '/etc/apache2/ports.conf',
  $template              = $::apache::params::template,
  $template_ports        = $::apache::params::template_ports,
  $servername            = undef,
  $serversignature       = undef,
  $servertokens          = undef,
  $fileetag              = undef,
  $include               = [],
  $proxyrequests         = undef,
  $proxypass             = undef,
  $proxy                 = [],
  $timeout               = undef,
  $keepalivetimeout      = undef,
  $limitrequestfields    = undef,
  $limitrequestfieldsize = undef,
  $listen                = [],
  $namevirtualhost       = [],
  $user                  = undef,
  $group                 = undef,
) inherits ::apache::params {
  package { $package_name: ensure => installed }
  file { $configfile:
    require => package[$package_name],
    content => template($template),
  }
  if $::osfamily == 'Debian' {
    file { $configfile_ports:
      require => package[$package_name],
      content => template($template_ports),
    }
  }
  if $::osfamily == 'RedHat' {
    service { 'httpd':
      require => package[$package_name],
      enable  => true,
    }
  }
}
